/*
 * File access convenience functions and types.
 *
 * Copyright (C) 2021 Paul Boddie <paul@boddie.org.uk>
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License as
 * published by the Free Software Foundation; either version 2 of
 * the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor,
 * Boston, MA  02110-1301, USA
 */

#include <l4/sys/types.h>

#include <systypes/base.h>



typedef struct
{
  l4_cap_idx_t ref;
  char *memory;
  offset_t start_pos, end_pos, data_end, size;
} file_t;

offset_t file_span(file_t *file);
void file_init(file_t *file);
long file_open(file_t *file, l4_cap_idx_t context_ref);
void file_close(file_t *file);
long file_mmap(file_t *file, offset_t position, offset_t length);
long context_open(file_t *file, l4_cap_idx_t server);

// vim: tabstop=2 expandtab shiftwidth=2
